#include <Wire.h> 
#include <Adafruit_NeoPixel.h>

#if defined(ARDUINO) && ARDUINO >= 100
#define printByte(args)  write(args);
#else
#define printByte(args)  print(args,BYTE);
#endif
uint8_t empty[8] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1f};
uint8_t heart[8] = {0x0,0xa,0x1f,0x1f,0xe,0x4,0x0,0x0};
#define address 0x1e

int length;
#define RGB_ws2812 10
Adafruit_NeoPixel strip = Adafruit_NeoPixel(60, RGB_ws2812, NEO_GRB + NEO_KHZ800);

#define EN1 6//右侧电机使能端
#define IN1 7//右侧电机方向端
#define EN2 5//左侧电机使能端
#define IN2 12//左侧电机方向端

#define FORW 0//前进
#define BACK 1//后退

#define IR_IN  17//红外接收
#define L_IR 13//左红外发送
#define R_IR 8//右红外发送

#define BUZZER 16//蜂鸣器

#define Vr   5//参考电压值

#define NTD0 -1
#define NTD1 294
#define NTD2 330
#define NTD3 350
#define NTD4 393
#define NTD5 441
#define NTD6 495
#define NTD7 556

#define NTDL1 147
#define NTDL2 165
#define NTDL3 175
#define NTDL4 196
#define NTDL5 221
#define NTDL6 248
#define NTDL7 278

#define NTDH1 589
#define NTDH2 661
#define NTDH3 700
#define NTDH4 786
#define NTDH5 882
#define NTDH6 990
#define NTDH7 112
//列出全部D调的频率
#define WHOLE 1
#define HALF 0.5
#define QUARTER 0.25
#define EIGHTH 0.25
#define SIXTEENTH 0.625
//列出所有节拍
int tune1[]=                 //根据简谱列出各频率
{
  NTDH3,NTDH3,NTDH2,NTDH3,NTD6,NTDH3,NTD6,NTD5,
  NTDH2,NTDH1,NTDH2,NTDH3,NTDH2,NTDH1,
  NTD6,NTDH3,NTDH2,NTDH3,NTDH2,NTDH1,NTD7,
  NTD6,NTD5,NTD6,NTD7,NTD6,NTD5
};
float durt1[]=                   //根据简谱列出各节拍
{
  0.5,0.5,1,0.5,1,1.5,1,1,
  0.5,0.5,1,0.5,1,2,
  1,1,0.5,0.5,1,0.5,1,
  0.5,0.5,1,0.5,1,2
};

int tonepin=16;   //得用16号接口
char xReadWriteData='S';
int   count;//对返回的脉冲进行计数
float data[7]={0X00,0X00,0X00,0X00,0x00,0xff,0x00};//存储8个通道ad转换的值
char  value[5]={0x00,0x00,0x00,0x00,0x00};//五个寻线传感器的电压值
char  key_1=0x00,key_2=0x00,key_3=0x00;//按键的计数值
//计数里程
int    count_r=0,count_l=0;//对左右轮返回的脉冲进行计数
//遥控参数
int Pulse_Width=0;//存储脉宽 
int  ir_code=0x00; //命令值
int SpeedNumL=200;
int SpeedNumR=200;
//控制电机转动
void Motor_Control(int M1_DIR,int M1_EN,int M2_DIR,int M2_EN)
{
  //////////M1////////////////////////
  if(M1_DIR==FORW)//M1方向为FORW
      digitalWrite(IN1,FORW); //向前
  else
    digitalWrite(IN1,BACK);//向后   
  if(M1_EN==0) //M1速度为0
      analogWrite(EN1,LOW);//置低，停止
  else
    analogWrite(EN1,M1_EN);//设置给定的数值

  ///////////M2//////////////////////
  if(M2_DIR==FORW) //M2方向为FORW
      digitalWrite(IN2,FORW);//向前
  else
    digitalWrite(IN2,BACK);//向后   
  if(M2_EN==0) //M2速度为0
      analogWrite(EN2,LOW);//置低，停止
  else//否则
  analogWrite(EN2,M2_EN);//设置给定的数值 
}
//避障
void L_Send40KHZ(void)//左发射管发射频率为40kHZ脉冲
{
  int i;
  for(i=0;i<24;i++)
  {
    digitalWrite(L_IR,LOW);//设置左发射管为高电平
    delayMicroseconds(8);//延时
    digitalWrite(L_IR,HIGH);//设置左发射管为低电平
    delayMicroseconds(8);//延时
  }
}
void R_Send40KHZ(void)//右发射管发射频率为40kHZ脉冲
{
  int i;
  for(i=0;i<24;i++)
  {
    digitalWrite(R_IR,LOW);//设置右发射管为高电平
    delayMicroseconds(8);//延时
    digitalWrite(R_IR,HIGH);//设置右发射管为低电平
    delayMicroseconds(8);//延时
  }
}
//计数里程
void LEFT(void)
{
 //左侧车轮返回脉冲计数
 //if(++count_l=100)
    count_l++;
}
void RIGHT(void)
{
 //右侧车轮返回脉冲计数
// if(++count_r=100)
    count_r++;
}
void pcint0_init(void)//引脚变化中断初始化
{
  PCICR = 0X01;//使能第0组引脚变化中断
  PCMSK0 = 0X01;//使能第0组的第0个引脚变化中断
}
ISR(PCINT0_vect)//PB0引脚变化中断
{
  count++;//计数接收到的脉冲
}
void Obstacle_Avoidance(void)//避障子函数
{   
  char i;
  count=0;
  for(i=0;i<20;i++)//左发射管发射20个脉冲
  {
    L_Send40KHZ();
    delayMicroseconds(600);    
  }
  if(count>20)//接收超过10个脉冲，判断有障碍物 
  {
      Motor_Control(BACK,SpeedNumR,BACK,SpeedNumL);//后退
      delay(50);//延时
      Motor_Control(BACK,SpeedNumR,FORW,SpeedNumL);//右转
      delay(50);//延时
  }
  else
  {
      Motor_Control(FORW,SpeedNumR,FORW,SpeedNumL);//前进
  }

  count=0;
  for(i=0;i<20;i++)//右发射管发射20个脉冲
  {
    R_Send40KHZ(); 
    delayMicroseconds(600);        
  }
  if(count>20)
  {
      Motor_Control(BACK,SpeedNumR,BACK,SpeedNumL);//后退
      delay(50);//延时
      Motor_Control(FORW,SpeedNumR,BACK,SpeedNumL);//左转
      delay(50);//延时
  }
  else
  {
      Motor_Control(FORW,SpeedNumR,FORW,SpeedNumL);//前进
  }
  
}
//读取模拟端口电压值
void Read_Value(void)
{  
  int i;
  for(i=0;i<7;i++)
  {
    data[i]=analogRead(i);//读取模拟i口电压值
    data[i]= ((data[i]*Vr)/1024); //转换成模拟值
  }
}
//寻线
void value_adjust(unsigned char num)//调整寻线传感器的值
{
  if(num==1)//调节第一个寻线传感器
  {
    if(data[0]>value[0])
    {
      colorWipe(strip.Color(0, 255, 0), 5); // Red
    }
    else
    {
      colorWipe(strip.Color(255, 0, 0), 1); // Green
    } 
  }
  if(num==2)//调节第二个寻线传感器
  {
    if(data[1]>value[1])
    {
      colorWipe(strip.Color(0, 255, 0), 1); // Red
    }
    else
    {
      colorWipe(strip.Color(255, 0, 0), 1); // Green
    } 
  }
  if(num==3)//调节第三个寻线传感器
  {
    if(data[2]>value[2])
    {
      colorWipe(strip.Color(0, 255, 0), 1); // Red
    }
    else
    {
      colorWipe(strip.Color(255, 0, 0), 1); // Green
    } 
  }
  if(num==4)//调节第四个寻线传感器
  {
    if(data[3]>value[3])
    {
      colorWipe(strip.Color(0, 255, 0), 1); // Red
    }
    else
    {
      colorWipe(strip.Color(255, 0, 0), 1); // Green
    } 
  }
  if(num==5)//调节第五个寻线传感器
  {
    if(data[4]>value[4])
    {
      colorWipe(strip.Color(0, 255, 0), 1); // Red
    }
    else
    {
      colorWipe(strip.Color(255, 0, 0), 1); // Green
    } 
  }
}
void huntline_deal(void)
{ 
 if(data[0]>(value[0]-1)&&data[1]>(value[1]-1)&&data[2]<(value[2])&&data[3]>(value[3]-1)&&data[4]>(value[4]-1))//测一下实际值
    Motor_Control(FORW,100,FORW,100);//前进
  else if(data[0]>(value[0]-1)&&data[1]>(value[1]-1)&&data[2]<(value[2]-1)&&data[3]<(value[3]-1)&&data[4]>(value[4]-1))
    Motor_Control(BACK,20,FORW,100);//右转
  else if(data[0]>(value[0]-1)&&data[1]>(value[1]-1)&&data[2]>(value[2]-1)&&data[3]<(value[3]-1)&&data[4]>(value[4]-1))
    Motor_Control(BACK,100,FORW,100);//快速右转	
  else if(data[0]>(value[0]-1)&&data[1]>(value[1]-1)&&data[2]>(value[2]-1)&&data[3]<(value[3]-1)&&data[4]<(value[4]-1))
    Motor_Control(BACK,100,FORW,100);//快速右转
  else if(data[0]>(value[0]-1)&&data[1]>(value[1]-1)&&data[2]>(value[2]-1)&&data[3]>(value[3]-1)&&data[4]<(value[4]-1))
    Motor_Control(BACK,100,FORW,100);//快速右转
  else if(data[0]>(value[0]-1)&&data[1]<(value[1]-1)&&data[2]<(value[2]-1)&&data[3]>(value[3]-1)&&data[4]>(value[4]-1))
    Motor_Control(FORW,100,BACK,20);//左转
  else if(data[0]>(value[0]-1)&&data[1]<(value[1]-1)&&data[2]>(value[2]-1)&&data[3]>(value[3]-1)&&data[4]>(value[4]-1))
    Motor_Control(FORW,100,BACK,100);//快速左转
  else if(data[0]<(value[0]-1)&&data[1]<(value[1]-1)&&data[2]>(value[2]-1)&&data[3]>(value[3]-1)&&data[4]>(value[4]-1))
    Motor_Control(FORW,100,BACK,100);//快速左转
  else if(data[0]<(value[0]-1)&&data[1]>(value[1]-1)&&data[2]>(value[2]-1)&&data[3]>(value[3]-1)&&data[4]>(value[4]-1))
    Motor_Control(FORW,100,BACK,100);//快速左转
}
//寻光
void hunt_light(void)//寻光子函数
{
  if (data[5]>3.5)   //根据实际的实验环境进行测量
    Motor_Control(BACK,SpeedNumR,FORW,SpeedNumL);//右转
  else if (data[5]< 1.5)
    Motor_Control(FORW,SpeedNumR,BACK,SpeedNumL);//
  else
    Motor_Control(FORW,0,FORW,0);//停止
}
//遥控功能函数
void timer1_init(void)
{
  TCCR1A = 0X00; 
  TCCR1B = 0X05;//给定时器时钟源  
  TCCR1C = 0X00;
  TCNT1 = 0X00;
  TIMSK1 = 0X00;	//禁止定时器溢出中断
}
void remote_deal(void)
{ 
  switch(ir_code)
  {
  case 0xff00:
    Motor_Control(FORW,0,FORW,0);//停止
    break;
  case 0xfe01:
    Motor_Control(FORW,100,FORW,100);//前进
    break;
  case 0xf609:
    Motor_Control(BACK,100,BACK,100);//后退
    break;
  case 0xfb04:
    Motor_Control(FORW,100,BACK,100);//左转
    break;
  case 0xf906:
    Motor_Control(BACK,100,FORW,100);//右转
    break;
  }
}
char logic_value()
{
  while(!(digitalRead(17))); //低等待
  Pulse_Width=TCNT1;
  TCNT1=0;
  if(Pulse_Width>=7&&Pulse_Width<=10)//低电平560us
  {
    while(digitalRead(17));//是高就等待
    Pulse_Width=TCNT1;
    TCNT1=0;
    if(Pulse_Width>=7&&Pulse_Width<=10)//接着高电平560us
      return 0;
    else if(Pulse_Width>=25&&Pulse_Width<=27) //接着高电平1.7ms
      return 1;
  }
  return -1;
}
void pulse_deal()
{
  int i;

  //执行8个0
  for(i=0; i<8; i++)
  {
    if(logic_value() != 0) //不是0
        return;
  }
  //执行6个1
  for(i=0; i<6; i++)
  {
    if(logic_value()!= 1) //不是1
        return;
  }
  //执行1个0
  if(logic_value()!= 0) //不是0
      return;
  //执行1个1
  if(logic_value()!= 1) //不是1
      return;

  //解析遥控器编码中的command指令
  ir_code=0x00;//清零
  for(i=0; i<16;i++ )
  {
    if(logic_value() == 1)
    {
      ir_code |=(1<<i);
    }
  }
}
void remote_decode(void)
{
  TCNT1=0X00;       
  while(digitalRead(17))//是高就等待
  {
    if(TCNT1>=1563)  //当高电平持续时间超过100ms，表明此时没有按键按下
    {
      ir_code = 0xff00;
      return;
    }  
  }

  //如果高电平持续时间不超过100ms
  TCNT1=0X00;

  while(!(digitalRead(17))); //低等待
  Pulse_Width=TCNT1;
  TCNT1=0;
  if(Pulse_Width>=140&&Pulse_Width<=141)//9ms
  {

    while(digitalRead(17));//是高就等待
    Pulse_Width=TCNT1;
    TCNT1=0;
    if(Pulse_Width>=68&&Pulse_Width<=72)//4.5ms
    {
      pulse_deal();
      return;
    }
    else if(Pulse_Width>=34&&Pulse_Width<=36)//2.25ms
    {
      while(!(digitalRead(17)));//低等待
      Pulse_Width=TCNT1;
      TCNT1=0;
      if(Pulse_Width>=7&&Pulse_Width<=10)//560us
      {
        return; 
      }
    }
  }
}
//蜂鸣器声音
void buzzer(void)//蜂鸣器发出一种声音
{
  digitalWrite(BUZZER,HIGH);//置高，蜂鸣器响
  delay(1);
  digitalWrite(BUZZER,LOW);//置低，蜂鸣器不响
  delay(10);
}
//按键扫描
void key_scan(void)
{
  if(data[6]>4.50&&data[6]<6.00)//没有按键按下
    return;//返回
  else
  {
    if(data[6]>=0.00&&data[6]<0.80)//按键1按下
    {
      delay(10);//延时消抖
      if(data[6]>=0.00&&data[6]<0.80)//按键1确实按下
      {
        buzzer();//蜂鸣器响
        while(data[6]>=0.00&&data[6]<0.80)
         Read_Value();
        key_1++;//按键1计数
        if(key_1>=1&&key_1<=5) 
          value_adjust(key_1);//寻线传感器的值调整
      }
    }
    else if(data[6]>=0.80&&data[6]<3)//按键2按下
    {
      delay(10);//延时消抖
      if(data[6]>=0.80&&data[6]<3)
      {
        buzzer();//蜂鸣器响
        while(data[6]>=0.50&&data[6]<3)
         Read_Value();
        if(key_1>=1&&key_1<=5)//按键1的值在1~5之间
        {
          value[key_1-1]++;//传感器的分辨轨迹的界限值加加（调整）
          value_adjust(key_1);//跟实际值对比
        }
        else
        {
          key_2++;//key2计数
        }
      }
    }
    else if(data[6]>=3&&data[6]<4)//按键3按下
    {
      delay(10);//延时消抖
      if(data[6]>=3&&data[6]<4)
      {
        buzzer();//蜂鸣器响
        while(data[6]>=3&&data[6]<4)
          Read_Value();
        if(key_1>=1&&key_1<=5)//按键1的值在1~5之间
        {
          value[key_1-1]--;//传感器的分辨轨迹的界限值减减（调整）
          value_adjust(key_1);//跟实际值对比
        }
        else
        {
          key_3++;//key3计数
        }
      }
    }
  }
}
void key_deal()
{
  if(key_1==6)//寻线
  {
    huntline_deal();//调用寻线处理子函数
    key_2=0x00;
    key_3=0x00;
  }
  else if(key_1 == 7)
  {
     key_1 = 0;
     Motor_Control(FORW,0,FORW,0);//停止
  }
}
//低电压检测
void low_voltage_check(void)
{ 
    float voltage_num=analogRead(A9);
    voltage_num=(15*voltage_num)/2048;
   if(voltage_num<4.0||voltage_num>7.0)
   {  
     while(1)
     {
       voltage_num=analogRead(A9);
        voltage_num=(15*voltage_num)/2048;
        if(voltage_num>=4.0&&voltage_num<=7.0)
          break;
        buzzer(); //蜂鸣器响
        colorWipe(strip.Color(0, 255, 0), 1); // Red
        colorWipe(strip.Color(0, 0, 0), 1);
     }
   }
}
void Velocity_function(void)//速度处理函数
{
  if(count_l>count_r)
  {
    SpeedNumL=SpeedNumL-1;
    SpeedNumR=SpeedNumR+1;
  }
  else if(count_l<count_r)
  {
    SpeedNumL=SpeedNumL+1;
    SpeedNumR=SpeedNumR-1;
  }
  count_l=0;
  count_r=0;  
}
void colorWipe(uint32_t c, uint8_t wait)
{
  for(uint16_t i=0; i<strip.numPixels(); i++)
 {
      strip.setPixelColor(i, c);
      strip.show();
      delay(wait);
  }
}

void setup()
{
  pinMode(5,OUTPUT);
  pinMode(6,OUTPUT);
  pinMode(7,OUTPUT);
  pinMode(12,OUTPUT);
  
  pinMode(8,OUTPUT);
  pinMode(10,OUTPUT);
  pinMode(13,OUTPUT);
  pinMode(14,OUTPUT);
  pinMode(16,OUTPUT);
  pinMode(17,INPUT);

  strip.begin();
  strip.show();
  
  length=sizeof(tune1)/sizeof(tune1[0]);   //计算长度
  
  Wire.begin(4);// 加入 i2c 总线，设置从机地址为 #4
  Wire.onReceive(receiveEvent);//注册接收到主机字符的事件
  Wire.onRequest(requestEvent);// 注册主机通知从机上传数据的事件
  
  attachInterrupt(2,RIGHT,FALLING);
  attachInterrupt(3,LEFT,FALLING);
  Motor_Control(FORW,0,FORW,0);
}
void loop()
{
  switch(xReadWriteData)
  {
    case'S':
      Motor_Control(FORW,0,FORW,0);
      break;
    case'M':
      MusicFunction();
      break;
    case'L':
      RGBFunction();
      break;
    case'A':
      LineFunction();
      break;
    case'E':
      LightFuntion();
      break;
    case'O':
      ObstacleFunction();
      break;
    case'w':
      Motor_Control(FORW,SpeedNumR,FORW,SpeedNumL);//前进
      break;
    case'a':
      Motor_Control(FORW,SpeedNumR,BACK,SpeedNumL);//左转
      break;
    case's':
      Motor_Control(BACK,SpeedNumR,BACK,SpeedNumL);//后退
      break;
    case'd':
      Motor_Control(BACK,SpeedNumR,FORW,SpeedNumL);//右转
      break;
  }
  Velocity_function();
//  low_voltage_check();
  colorWipe(strip.Color(0, 0, 0), 1);
}

// 当从机接收到主机字符，执行该事件
void receiveEvent(int howMany)
{
  while( Wire.available()>1) // 循环执行，直到数据包只剩下最后一个字符
  {
    char c = Wire.read(); // 作为字符接收字节
  }
   //接收主机发送的数据包中的最后一个字节
  xReadWriteData = Wire.read();    // 作为整数接收字节
}

//当主机通知从机上传数据，执行该事件
void requestEvent()
{
  float analog = analogRead(A9);
  analog =(15*analog)/2048;
  if(analog>4.7)
    Wire.write( '3'); 
  else if(analog>4.3)
    Wire.write( '2'); 
  else if(analog>3.9)
    Wire.write( '1'); 
  else
    Wire.write( '0'); 
 // 响应主机的通知，向主机发送一个字节数据
}

uint32_t Wheel(byte WheelPos) 
{
  if(WheelPos < 85)
  {
   return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  } 
  else if(WheelPos < 170)
  {
   WheelPos -= 85;
   return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  else 
  {
   WheelPos -= 170;
   return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
}

void rainbow(uint8_t wait)
{
  uint16_t i, j;

  for(j=0; j<256; j++)
  {
    for(i=0; i<strip.numPixels(); i++)
    {
      strip.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

// Slightly different, this makes the rainbow equally distributed throughout
void rainbowCycle(uint8_t wait) 
{
  uint16_t i, j;

  for(j=0; j<256*5; j++) 
  { // 5 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) 
    {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

void MusicFunction(void)//
{
  for(int x=0;x<length;x++)
  {
    tone(tonepin,tune1[x]);
    delay(350*durt1[x]);   //这里用来根据节拍调节延时，500这个指数可以自己调整，在该音乐中，我发现用500比较合适。
    noTone(tonepin);
  }
}

void RGBFunction(void)//
{
  rainbow(5);
  rainbowCycle(5);
}

void LineFunction(void)//
{
  //buzzer();//蜂鸣器响
  Read_Value();
  key_scan();
  key_deal();
}

void LightFuntion(void)//
{
   Read_Value();
   hunt_light();//调用寻光子函数
   Velocity_function();//速度处理函数
}

void ObstacleFunction(void)//
{
  pcint0_init();//引脚变化中断初始化
  sei();     //全局中断使能
  Obstacle_Avoidance();
  Velocity_function();
}


